---
title: Subscriptions
---

[Skip to content](#_top)

[API Reference](https://developers.cloudflare.com/api/python)

[Accounts](https://developers.cloudflare.com/api/python/resources/accounts)

Copy Markdown

Open in **Claude**Open in **ChatGPT**Open in **Cursor**

---

**Copy Markdown****View as Markdown**

# Subscriptions

##### [List Subscriptions](https://developers.cloudflare.com/api/python/resources/accounts/subresources/subscriptions/methods/get)

accounts.subscriptions.get(SubscriptionGetParams\*\*kwargs) -> SyncSinglePage\[[Subscription](<https://developers.cloudflare.com/api/python/resources/$shared#(resource)%20%24shared%20%3E%20(model)%20subscription%20%3E%20(schema)>)]

GET/{accounts\_or\_zones}/{account\_or\_zone\_id}/subscriptions

##### [Get Subscription](https://developers.cloudflare.com/api/python/resources/accounts/subresources/subscriptions/methods/get_by_identifier)

accounts.subscriptions.get\_by\_identifier(strsubscription\_identifier, SubscriptionGetByIdentifierParams\*\*kwargs) -> [Subscription](<https://developers.cloudflare.com/api/python/resources/$shared#(resource)%20%24shared%20%3E%20(model)%20subscription%20%3E%20(schema)>)

GET/accounts/{account\_id}/subscriptions/{subscription\_identifier}

##### [Create Subscription](https://developers.cloudflare.com/api/python/resources/accounts/subresources/subscriptions/methods/create)

accounts.subscriptions.create(SubscriptionCreateParams\*\*kwargs) -> [Subscription](<https://developers.cloudflare.com/api/python/resources/$shared#(resource)%20%24shared%20%3E%20(model)%20subscription%20%3E%20(schema)>)

POST/{accounts\_or\_zones}/{account\_or\_zone\_id}/subscriptions

##### [Update Subscription](https://developers.cloudflare.com/api/python/resources/accounts/subresources/subscriptions/methods/update)

accounts.subscriptions.update(strsubscription\_identifier, SubscriptionUpdateParams\*\*kwargs) -> [Subscription](<https://developers.cloudflare.com/api/python/resources/$shared#(resource)%20%24shared%20%3E%20(model)%20subscription%20%3E%20(schema)>)

PUT/accounts/{account\_id}/subscriptions/{subscription\_identifier}

##### [Delete Subscription](https://developers.cloudflare.com/api/python/resources/accounts/subresources/subscriptions/methods/delete)

accounts.subscriptions.delete(strsubscription\_identifier, SubscriptionDeleteParams\*\*kwargs) -> [SubscriptionDeleteResponse](<https://developers.cloudflare.com/api/python/resources/accounts#(resource)%20accounts.subscriptions%20%3E%20(model)%20subscription_delete_response%20%3E%20(schema)>)

DELETE/accounts/{account\_id}/subscriptions/{subscription\_identifier}

##### [Cancel Delayed Downgrade](https://developers.cloudflare.com/api/python/resources/accounts/subresources/subscriptions/methods/cancel_downgrade)

accounts.subscriptions.cancel\_downgrade(SubscriptionCancelDowngradeParams\*\*kwargs) -> [SubscriptionCancelDowngradeResponse](<https://developers.cloudflare.com/api/python/resources/accounts#(resource)%20accounts.subscriptions%20%3E%20(model)%20subscription_cancel_downgrade_response%20%3E%20(schema)>)

POST/accounts/{account\_id}/subscriptions/cancel-downgrade

##### ModelsExpand Collapse

<details>

<summary>

class SubscriptionDeleteResponse: …

</summary>

subscription\_id: Optional\[str]

Subscription identifier tag.

maxLength32

<a href="#(resource)%20accounts.subscriptions%20%3E%20(model)%20subscription_delete_response%20%3E%20(schema)%20%3E%20(property)%20subscription_id">Link to this property</a>

</details>

[Link to this property](<#(resource)%20accounts.subscriptions%20%3E%20(model)%20subscription_delete_response%20%3E%20(schema)>)

<details>

<summary>

Union\[Optional\[str], Optional\[object]]

</summary>

One of the following:

Optional\[str]

<a href="#(resource)%20accounts.subscriptions%20%3E%20(model)%20subscription_cancel_downgrade_response%20%3E%20(schema)%20%3E%20(variant)%201">Link to this property</a>

Optional\[object]

<a href="#(resource)%20accounts.subscriptions%20%3E%20(model)%20subscription_cancel_downgrade_response%20%3E%20(schema)%20%3E%20(variant)%200">Link to this property</a>

</details>

[Link to this property](<#(resource)%20accounts.subscriptions%20%3E%20(model)%20subscription_cancel_downgrade_response%20%3E%20(schema)>)

#### SubscriptionsCancel Reason

##### [Create Cancel Reason](https://developers.cloudflare.com/api/python/resources/accounts/subresources/subscriptions/subresources/cancel_reason/methods/create)

accounts.subscriptions.cancel\_reason.create(strsubscription\_identifier, CancelReasonCreateParams\*\*kwargs) -> [CancelReasonCreateResponse](<https://developers.cloudflare.com/api/python/resources/accounts#(resource)%20accounts.subscriptions.cancel_reason%20%3E%20(model)%20cancel_reason_create_response%20%3E%20(schema)>)

POST/accounts/{account\_id}/subscriptions/{subscription\_identifier}/cancel-reason

##### [Get Cancel Reason](https://developers.cloudflare.com/api/python/resources/accounts/subresources/subscriptions/subresources/cancel_reason/methods/get)

accounts.subscriptions.cancel\_reason.get(strsubscription\_identifier, CancelReasonGetParams\*\*kwargs) -> [CancelReasonGetResponse](<https://developers.cloudflare.com/api/python/resources/accounts#(resource)%20accounts.subscriptions.cancel_reason%20%3E%20(model)%20cancel_reason_get_response%20%3E%20(schema)>)

GET/accounts/{account\_id}/subscriptions/{subscription\_identifier}/cancel-reason

##### ModelsExpand Collapse

<details>

<summary>

class CancelReasonCreateResponse: …

</summary>

id: Optional\[str]

The cancel reason identifier.

<a href="#(resource)%20accounts.subscriptions.cancel_reason%20%3E%20(model)%20cancel_reason_create_response%20%3E%20(schema)%20%3E%20(property)%20id">Link to this property</a>

other: Optional\[str]

Additional cancellation details.

<a href="#(resource)%20accounts.subscriptions.cancel_reason%20%3E%20(model)%20cancel_reason_create_response%20%3E%20(schema)%20%3E%20(property)%20other">Link to this property</a>

reason\_code: Optional\[List\[str]]

The cancellation reason codes.

<a href="#(resource)%20accounts.subscriptions.cancel_reason%20%3E%20(model)%20cancel_reason_create_response%20%3E%20(schema)%20%3E%20(property)%20reason_code">Link to this property</a>

submitted: Optional\[datetime]

When the cancel reason was submitted.

formatdate-time

<a href="#(resource)%20accounts.subscriptions.cancel_reason%20%3E%20(model)%20cancel_reason_create_response%20%3E%20(schema)%20%3E%20(property)%20submitted">Link to this property</a>

subscription\_id: Optional\[str]

The subscription identifier.

<a href="#(resource)%20accounts.subscriptions.cancel_reason%20%3E%20(model)%20cancel_reason_create_response%20%3E%20(schema)%20%3E%20(property)%20subscription_id">Link to this property</a>

</details>

[Link to this property](<#(resource)%20accounts.subscriptions.cancel_reason%20%3E%20(model)%20cancel_reason_create_response%20%3E%20(schema)>)

<details>

<summary>

class CancelReasonGetResponse: …

</summary>

id: Optional\[str]

The cancel reason identifier.

<a href="#(resource)%20accounts.subscriptions.cancel_reason%20%3E%20(model)%20cancel_reason_get_response%20%3E%20(schema)%20%3E%20(property)%20id">Link to this property</a>

other: Optional\[str]

Additional cancellation details.

<a href="#(resource)%20accounts.subscriptions.cancel_reason%20%3E%20(model)%20cancel_reason_get_response%20%3E%20(schema)%20%3E%20(property)%20other">Link to this property</a>

reason\_code: Optional\[List\[str]]

The cancellation reason codes.

<a href="#(resource)%20accounts.subscriptions.cancel_reason%20%3E%20(model)%20cancel_reason_get_response%20%3E%20(schema)%20%3E%20(property)%20reason_code">Link to this property</a>

submitted: Optional\[datetime]

When the cancel reason was submitted.

formatdate-time

<a href="#(resource)%20accounts.subscriptions.cancel_reason%20%3E%20(model)%20cancel_reason_get_response%20%3E%20(schema)%20%3E%20(property)%20submitted">Link to this property</a>

subscription\_id: Optional\[str]

The subscription identifier.

<a href="#(resource)%20accounts.subscriptions.cancel_reason%20%3E%20(model)%20cancel_reason_get_response%20%3E%20(schema)%20%3E%20(property)%20subscription_id">Link to this property</a>

</details>

[Link to this property](<#(resource)%20accounts.subscriptions.cancel_reason%20%3E%20(model)%20cancel_reason_get_response%20%3E%20(schema)>)

#### SubscriptionsActions

##### [Append Subscription Action](https://developers.cloudflare.com/api/python/resources/accounts/subresources/subscriptions/subresources/actions/methods/append)

accounts.subscriptions.actions.append(strsubscription\_identifier, ActionAppendParams\*\*kwargs) -> [Subscription](<https://developers.cloudflare.com/api/python/resources/$shared#(resource)%20%24shared%20%3E%20(model)%20subscription%20%3E%20(schema)>)

POST/accounts/{account\_id}/subscriptions/{subscription\_identifier}/action/append

#### SubscriptionsBulk

##### [Create Subscriptions](https://developers.cloudflare.com/api/python/resources/accounts/subresources/subscriptions/subresources/bulk/methods/create)

accounts.subscriptions.bulk.create(BulkCreateParams\*\*kwargs) -> [BulkCreateResponse](<https://developers.cloudflare.com/api/python/resources/accounts#(resource)%20accounts.subscriptions.bulk%20%3E%20(model)%20bulk_create_response%20%3E%20(schema)>)

POST/accounts/{account\_id}/bulk/subscriptions

##### ModelsExpand Collapse

Optional\[List\[object]]

[Link to this property](<#(resource)%20accounts.subscriptions.bulk%20%3E%20(model)%20bulk_create_response%20%3E%20(schema)>)